题目描述
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
题意概况,一个b首相想改自己的四位门牌号,从门牌号x改到门牌号y,改动要求:
一次只能改动一个数字,保证改动后仍是四位的质数。
然而改动需要money,一次一r,财政部长希望减小开销,所以让你来求最小的改动次数。
输入:一共询问T次,对每次询问输入x,y
输出:输出最小的改动次数或者”Impossible”
简单,直接get1000到9999所有的质数,然后从x开始bfs直至找到y,如果找不到return -1
#include<iostream>
#include<cstring>
#include<queue>
#include<map>
using namespace std;
int x, y;
int st[10010];
map<int, bool> mp;
void get(int n)//埃式筛法-O(nloglogn)
{
for(int i = 2; i <= n; i++)
{
if(!st[i])
{
if(i >= 1000) mp[i] = 1;
for(int j = i + i; j <= n; j += i) st[j] = 1;
}
}
}
int bfs()
{
queue<int> q;
q.push(x);
st[x] = 0;
while(q.size())
{
if(st[y] != -1) return st[y];
int t = q.front();
q.pop();
int a = t / 1000;
int b = (t / 100) % 10;
int c = (t / 10) % 10;
int d = t % 10;
int num;
for(int i = 0; i < 10; i++)
{
num = a * 1000 + b * 100 + c * 10 + i;
if(st[num] == -1 && mp[num]) q.push(num), st[num] = st[t] + 1;
num = a * 1000 + b * 100 + i * 10 + d;
if(st[num] == -1 && mp[num]) q.push(num), st[num] = st[t] + 1;
num = a * 1000 + i * 100 + c * 10 + d;
if(st[num] == -1 && mp[num]) q.push(num), st[num] = st[t] + 1;
num = i * 1000 + b * 100 + c * 10 + d;
if(st[num] == -1 && mp[num]) q.push(num), st[num] = st[t] + 1;
}
}
return -1;
}
int main()
{
memset(st, 0, sizeof st);
get(9999);
int T;
cin >> T;
while(T--)
{
memset(st, -1, sizeof st);
cin >> x >> y;
int ans = bfs();
if(ans != -1) cout << ans << endl;
else
puts("Impossible");
}
return 0;
}